#!/usr/bin/perl
#
# BANNERMATIC 2 - Version using HTTP cookies
#
# Operates rotating banners and tracks display and click-thru stats.
#
#     Filename: banmat2.cgi
#    Copyright: 1997,1998 by Joe DePasquale
# Last Revised: August 29, 1998
#       E-Mail: crypt@getcruising.com
#      Website: http://www.GetCruising.com
#
# See the document 'how2ban.txt' for set-up instructions.
#
########################################################################
#                                                                      #
# This script and accompanying files may be distributed freely         #
# and modified, provided this header with my name, E-Mail address and  #
# this notice remain intact. Ownership rights remain with me. You may  #
# not sell this script without my approval.                            #
#                                                                      #
# This script comes with no guarantee or warranty except for my good   #
# intentions. By using this code you agree to indemnify me from any    #
# liability that might arise from it's use.                            #
#                                                                      #
# There is no technical support for this script, neither am I a        #
# professional programmer. Refer to 'HELPME.TXT' for general guidance. #
#                                                                      #
########################################################################
#
# CONFIGURE THE SCRIPT -
#
# Change these sample paths to the actual paths on your server:

# Your Unix system sendmail and date commands
$mailCmd = '/usr/sbin/sendmail';
$dateCmd = '/bin/date';

# Your E-Mail address - note mandatory backslash before \@
$myMail = "yourmail\@your-server.com";

# Unix path to banmat directory
$banmatDir = '/usr/home/yourpath/to/banmat';

# URL to the banmat directory
$banmatUrl = 'http://your-server.com/banmat';

# URL to banmat2.cgi
$scriptUrl = 'http://your-server.com/cgi-bin/banmat2.cgi';

# Go to this URL when exiting manager
$exitUrl = 'http://your-server.com/anypage.html';

# If you use Example #2 above, when a user clicks the small
# banner (promo.gif), where should the script send them?
$promoUrl = 'http://www.GetCruising.com/crypt/';

# If you want a signature file attached to mail messages,
# uncomment the next line and enter the correct Unix path ..
# $MYSIG = '/usr/home/yourpath/to/mysig.txt';

# .. otherwise uncomment the next 2 lines and replace with your info ..
# $myName = 'Bonzo Clone';
# $homeUrl = 'http://your-server.com/anypage.html';

# If you use 'group' codes and no banner is found with the required
# code, which banner number (in ban.dat) should be defaulted to?
# Also, cookie-challenged browsers will ALWAYS get this banner.
$failBan = 0;

# OPTIONAL - YOU CAN EDIT THESE VARIABLES IF DESIRED:

# If a browser does not have a cookie, the cookie-test determines if
# the browser is cookie-capable. If you don't use the test, a first-time
# visitor will be shown default $failBan until they get their first
# cookie. Change $myDomain to your domain name (always omit leading 'www')
# OR change $testFlag to 'N' to disable cookie-test.
$testFlag = 'Y';
$myDomain = ".your-server.com";

# Browser will keep retrieving same banner associated with a pagecode
# until banner is deleted from cache. If using animated GIF's you should
# set to 'Y' to avoid 'slideshow'. Otherwise use 'N' (but try both!)
$cacheFlag = 'Y';

# If you use HITMATIC, save yourself from having to place HTML for both
# scripts on the same web page. If $hitFlag is 'Y', after Bannermatic
# runs an 'IMG' command, it passes pagecode and group to HITMATIC.
$hitFlag = 'N';

# If you don't want to backup the ban.dat files, set $bakFlag to 'N',
# otherwise you can configure the values in the 'if' loop ..
$bakFlag = 'Y';

if ($bakFlag eq 'Y')
{ $bakTime = 1; # days btwn backups
  $bakMax  = 7; # days to keep backups 

  # Unix path to backup directory
  $bakDir = '/usr/home/yourpath/to/bak';

# END OF INSTALLATION - SHOULD NOT CHANGE STUFF BELOW THIS LINE
###########################################################################

  chop ($jDate = `$dateCmd +"%j"`);
  $BANBAK = "$bakDir/ban$jDate.bak";
}
chop ($timeStamp = `$dateCmd +"%a %D %H%M%Z"`);
chop ($dateStamp = `$dateCmd +"%Y%m%d"`);
chop ($hourStamp = `$dateCmd +"%H"`);
chop ($dowStamp  = `$dateCmd +"%w"`);

$BANDAT = "$banmatDir/ban.dat";
$BANFLK = "$banmatDir/ban.flk";
$BANLOG = "$banmatDir/ban.log";

########################################################################
# Get stuff and read input from query string

if (-e "referer.pl")
{ require "./referer.pl";
  &referer;
}
if ($ENV{'QUERY_STRING'} eq 'manager' || $ENV{'REQUEST_METHOD'} eq 'POST')
{ require "./banman.pl";
  $BANUNDO = "$banmatDir/ban.bak";
  $BANPWD = "$banmatDir/banmat.pwd";
  &banman;
  exit;
} elsif ($ENV{'QUERY_STRING'} =~ /(\S+?)(\+(\S))?=(\S+?)(\+(\S+?))?(&.*|$)/)
{ $pagecode =$1; $group =$3; $command =$4; $result =$6; 

  # Test Cookieness
  if ($ENV{'HTTP_COOKIE'} || $testFlag eq 'N')
  { $result = 'Y';
  } elsif ($result eq 'TEST')
  { $result = 'N';
  } else
  { print "Set-Cookie: banmat=Y; expires=Sat, 31 Dec 2299 12:00:00 GMT; path=/; domain=$myDomain\n";
    print "Location: $scriptUrl?$pagecode+$group=$command+TEST\n\n";
    exit;
  }
} else # bounce bad input
{ &endIt; 
}
######################################################################
# Case: Send banner Image to browser

if ($command =~ /IMG(X?)/)
{ 
  open (LOCK,">$BANFLK") || &endIt;
  if (!flock (LOCK,2)) { &endIt; }

  # Get the banner info
  open (DAT,"+<$BANDAT") || &endIt;
  flock (DAT,2); seek (DAT,0,0);
  @banFile = <DAT>;

  if ($result eq 'Y')
  {
    srand (time^$$);
    @ndx = (0..$#banFile);
    while ((!defined $banNbr) && $#ndx >=0)
    {
      $x = int (rand($#ndx +1));
      @banLine = split(/\|/,$banFile[$ndx[$x]]);
      if ($banLine[4] =~ /$group/)
      { $banNbr = $ndx[$x];
      } else
      { splice (@ndx,$x,1);
      }
    }
  } 
  if (!defined $banNbr)
  { $banNbr = $failBan;
    @banLine = split(/\|/,$banFile[$banNbr]);
  }
  # count the impression
  $banLine[3] ++;
  $banFile[$banNbr] = join ("\|",@banLine);

  seek (DAT,0,0);
  print (DAT @banFile);
  truncate (DAT,tell(DAT)); close (DAT);

  $imageExt = substr($banLine[1],rindex($banLine[1],".")+1);

  # send cookie and image to browser
  if ($cacheFlag eq 'N')
  { print "Expires: Wed, 01 Jan 1997 12:00:00 GMT\n";
  }
  print "Set-Cookie: $pagecode=$banNbr\n";
  print "Content-type: image/$imageExt\n\n";

  $IMGDAT = "$banmatDir/$banLine[1]";
  open (IMG,"<$IMGDAT") || &endIt;
  read (IMG,$imgDat,-s $IMGDAT);
  print $imgDat; close (IMG);

  if ($bakFlag eq 'Y' && ($jDate % $bakTime ==0) && !-e $BANBAK)
  { &backUp (@banFile);
  }
  close (LOCK);

  if ($hitFlag eq 'Y' && $command eq "IMG")
  { do "hitmat.cgi";
  }
} # end IMG

######################################################################
# Case: Send browser to the banner's URL

elsif ($command eq "URL")
{
  open (LOCK,">$BANFLK") || &endIt;
  if (!flock (LOCK,2)) { &endIt; }

  if ($result eq 'Y')
  { @cookiePairs = split (/; /,$ENV{'HTTP_COOKIE'});
    $x=0;
    do
    { ($name,$value) = split(/=/,$cookiePairs[$x]);
      if ($name eq $pagecode) { $banNbr = $value; }
      $x++;
    } until (defined $banNbr || $x >$#cookiePairs);
  }
  if (!defined $banNbr) { $banNbr = $failBan; }

  # Get the banner info
  open (DAT,"+<$BANDAT") || &endIt;
  flock (DAT,2); seek (DAT,0,0);
  @banFile = <DAT>;

  if ($banNbr <= $#banFile)
  { @banLine = split(/\|/,$banFile[$banNbr]);
    # count the click-thru
    $banLine[2] ++;
    $banFile[$banNbr] = join ("\|",@banLine);
  
    seek (DAT,0,0);
    print (DAT @banFile);
    truncate (DAT,tell(DAT));

    # send browser to URL for IMG
    print "Content-type: text/html\n";
    print "Window-target: _top\n";
    print "Location: $banLine[0]\n\n";

    # log the click-thru
    $banLog = join ("\|",$timeStamp,$banLine[0],$pagecode,$group,$ENV{'REMOTE_ADDR'},$ENV{'HTTP_REFERER'});
    open (LOG,">>$BANLOG");
    flock (LOG,2); seek (LOG,0,2);
    print (LOG "$banLog\n");
    close (LOG);
  } else
  { print "Content-type: text/html\n\n";
    print "Banner Requested Does Not Exist ($banLine[0])<br>\n";
  }
  close (DAT);
  close (LOCK);
} # end  URL

######################################################################
# Case: Send browser to promo page

elsif ($command eq "PROMO")
{ 
  print "Content-type: text/html\n";
  print "Window-target: _top\n";
  print "Location: $promoUrl\n\n";

  # log the click-thru
  $banLog = join ("\|",$timeStamp,$promoUrl,$pagecode,$group,$ENV{'REMOTE_ADDR'},$ENV{'HTTP_REFERER'});
  open (LOG,">>$BANLOG");
  flock (LOG,2); seek (LOG,0,2);
  print (LOG "$banLog\n");
  close (LOG);
} # end promo

exit; # end program

##################################################################

sub backUp # Backup data and delete old backups
{
  @bakData = @_;
  open (BAK,">$BANBAK") || &endIt;
  print (BAK @bakData);
  close (BAK);
  chmod (0666,$BANBAK);

  opendir (BAKDIR,$bakDir);
  @bakFiles = grep (/ban\d{3}\.bak/, readdir(BAKDIR));
  closedir (BAKDIR);

  foreach $bakFile (@bakFiles)
  { if (-M "$bakDir/$bakFile" > $bakMax) { unlink "$bakDir/$bakFile"; }
  }
} # end backup

sub endIt # error handling for user script
{ exit;
}
